import { defineComponent, inject, provide, renderSlot } from 'vue';
function createValue() {
    var isReset = false;
    return {
        clearReset: function () {
            isReset = false;
        },
        reset: function () {
            isReset = true;
        },
        isReset: function () {
            return isReset;
        },
    };
}
var symbol = Symbol('QueryErrorResetBoundary');
// HOOK
export var useQueryErrorResetBoundary = function () {
    return inject(symbol, createValue());
};
// COMPONENT
export var QueryErrorResetBoundary = defineComponent({
    name: 'QueryErrorResetBoundary',
    setup: function (_, _a) {
        var slots = _a.slots;
        var value = createValue();
        provide(symbol, value);
        return function () { return renderSlot(slots, 'default', value); };
    },
});
