"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.QueryClientProvider = exports.useQueryClient = void 0;
/**
 * queryclient服务提供者
 */
var vue_1 = require("vue");
var core_1 = require("../core");
var symbol = Symbol('QueryClientProvider');
var useQueryClient = function () {
    var queryClient = vue_1.inject(symbol, undefined);
    if (!queryClient) {
        throw new Error('No QueryClient set, use QueryClientProvider to set one');
    }
    return queryClient;
};
exports.useQueryClient = useQueryClient;
// 服务提供者
exports.QueryClientProvider = vue_1.defineComponent({
    name: 'QueryClientProvider',
    props: {
        client: {
            type: core_1.QueryClient,
            required: true,
        },
    },
    setup: function (props, _a) {
        var slots = _a.slots;
        vue_1.provide(symbol, props.client);
        vue_1.onMounted(function () {
            props.client.mount();
        });
        vue_1.onUnmounted(function () {
            props.client.unmount();
        });
        return function () { var _a; return (_a = slots.default) === null || _a === void 0 ? void 0 : _a.call(slots); };
    },
});
