"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.QueryErrorResetBoundary = exports.useQueryErrorResetBoundary = void 0;
var vue_1 = require("vue");
function createValue() {
    var isReset = false;
    return {
        clearReset: function () {
            isReset = false;
        },
        reset: function () {
            isReset = true;
        },
        isReset: function () {
            return isReset;
        },
    };
}
var symbol = Symbol('QueryErrorResetBoundary');
// HOOK
var useQueryErrorResetBoundary = function () {
    return vue_1.inject(symbol, createValue());
};
exports.useQueryErrorResetBoundary = useQueryErrorResetBoundary;
// COMPONENT
exports.QueryErrorResetBoundary = vue_1.defineComponent({
    name: 'QueryErrorResetBoundary',
    setup: function (_, _a) {
        var slots = _a.slots;
        var value = createValue();
        vue_1.provide(symbol, value);
        return function () { return vue_1.renderSlot(slots, 'default', value); };
    },
});
