"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.useIsFetching = void 0;
var vue_1 = require("vue");
var utils_1 = require("../core/utils");
var QueryClientProvider_1 = require("./QueryClientProvider");
function useIsFetching(arg1, arg2) {
    var queryClient = QueryClientProvider_1.useQueryClient();
    var filters = utils_1.parseFilterArgs(arg1, arg2)[0];
    var isFetching = vue_1.ref(queryClient.isFetching(filters));
    // 订阅观察者
    var unsubscribe;
    vue_1.onMounted(function () {
        unsubscribe = queryClient.getQueryCache().subscribe(function (res) {
            var newIsFetching = queryClient.isFetching(filters);
            if (isFetching.value !== newIsFetching) {
                isFetching.value = newIsFetching;
            }
        });
    });
    vue_1.onUnmounted(function () {
        unsubscribe === null || unsubscribe === void 0 ? void 0 : unsubscribe();
    });
    return isFetching;
}
exports.useIsFetching = useIsFetching;
