"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.useMutation = void 0;
var vue_1 = require("vue");
var utils_1 = require("../core/utils");
var mutationObserver_1 = require("../core/mutationObserver");
var QueryClientProvider_1 = require("./QueryClientProvider");
function useMutation(arg1, arg2, arg3) {
    var options = utils_1.parseMutationArgs(arg1, arg2, arg3);
    var queryClient = QueryClientProvider_1.useQueryClient();
    var observer = new mutationObserver_1.MutationObserver(queryClient, options);
    vue_1.watchEffect(function () {
        var options = utils_1.parseMutationArgs(arg1, arg2, arg3);
        observer.setOptions(options);
    });
    var currentResult = vue_1.reactive(observer.getCurrentResult());
    // 订阅数据的变化
    var unsubscribe;
    vue_1.onMounted(function () {
        unsubscribe = observer.subscribe(function (res) {
            Object.assign(currentResult, res);
        });
    });
    vue_1.onUnmounted(function () {
        unsubscribe === null || unsubscribe === void 0 ? void 0 : unsubscribe();
    });
    // 突变函数
    var mutate = function (variables, mutateOptions) {
        observer.mutate(variables, mutateOptions).catch(utils_1.noop);
    };
    return __assign(__assign({}, vue_1.toRefs(currentResult)), { mutate: mutate, mutateAsync: currentResult.mutate });
}
exports.useMutation = useMutation;
